/*
**  First Person Sniper
** By PikaJade
** Based on Fang Popgun Modifications / Aerial Popgun by Clairebun
** New hand sprites by Dry_Ny
*/

//Add cvars
local corkradius = CV_RegisterVar({name = "fangcorkradius", defaultvalue = 8, flags = CV_NOINIT|CV_CALL|CV_NETVAR|CV_CHEAT, PossibleValue = {MIN = 1, MAX = 15}, func = function(var)	
	print("Cork radius set to " .. var.value .. " fracunits")
end})
local corkspeed = CV_RegisterVar({name = "fangcorkspeed", defaultvalue = 100, flags = CV_NOINIT|CV_CALL|CV_NETVAR|CV_CHEAT, PossibleValue = CV_Natural, func = function(var)
	print("Cork speed set to " .. var.value .. " fu/t")
end})
local clipsize = CV_RegisterVar({name = "fangclipsize", defaultvalue = 2, flags = CV_NOINIT|CV_CALL|CV_NETVAR|CV_CHEAT, PossibleValue = CV_Natural, func = function(var)
	print("Clip size set to " .. var.value .. " corks")
	for p in players.iterate
		if p.mo
		and p.mo.skin == "fang"
			p.ammo = var.value
		end
	end
end})
local refiretime = CV_RegisterVar({name = "fangrefiretime", defaultvalue = 15, flags = CV_NOINIT|CV_CALL|CV_NETVAR|CV_CHEAT, PossibleValue = CV_Natural, func = function(var)
	print("Shot delay set to " .. var.value .. " tics")
end})
local fireinput = CV_RegisterVar({name = "fangfireinput", defaultvalue = "fire", flags = CV_NOINIT|CV_CALL|CV_NETVAR, PossibleValue = {none = 0, fire = 1, firenormal = 2, custom1 = 3, custom2 = 4, custom3 = 5}, func = function(var)
	if var.value == 0
		print("Attack with Spin")
	elseif var.value == 1
		print("Attack with Spin or Fire")
	elseif var.value == 2
		print("Attack with Spin or Fire Normal")
	elseif var.value == 3
		print("Attack with Spin or Custom 1")
	elseif var.value == 4
		print("Attack with Spin or Custom 2")
	elseif var.value == 5
		print("Attack with Spin or Custom 3")
	end
end})
local babyface = CV_RegisterVar({name = "fangfragboost", defaultvalue = "Off", flags = CV_NOINIT|CV_CALL|CV_NETVAR, PossibleValue = CV_OnOff, func = function(var)
	if var.value
		print("Boost meter on")
	else
		print("Boost meter off")
	end
end})
local babyfacelimit = CV_RegisterVar({name = "fangfraglimit", defaultvalue = 24, flags = CV_NOINIT|CV_CALL|CV_NETVAR|CV_CHEAT, PossibleValue = CV_Natural, func = function(var)
	print("Boost meter limit set to " .. var.value .. " frags")
	for p in players.iterate
		if p.mo
		and p.mo.skin == "fang"
		and p.kills
		and p.kills > var.value
			p.kills = var.value
			p.killsbar = 150
		end
	end
end})

//Define air shooting sprites
freeslot("SPR2_FAIR","S_PLAY_AIRFIRE1","S_PLAY_AIRFIRE2","sfx_rldend","sfx_nmehit","sfx_msfire","sfx_reload","sfx_qkdraw")
states[S_PLAY_AIRFIRE1] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
states[S_PLAY_AIRFIRE2] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
local airstate1 = S_PLAY_AIRFIRE1
local airstate2 = S_PLAY_AIRFIRE2
local reloadsound = sfx_reload
local reloadfinishsound = sfx_rldend
local misfiresound =  sfx_msfire
local hitenemysound = sfx_nmehit
local handoffy = {0,0}
local handoffx = {0,0}
local reloffx = {0,0}
local reloffy = {0,0}

local IsFang = function(player)
	return player.mo and player.mo.skin == "fang"
end

local function zpos(posmo, item)
	return (posmo.z + (posmo.height - mobjinfo[item].height)/2)
end

local function newGunslinger(player)
		
	if player.fpsslidenow
		return end
		
	local mo = player.mo
	local onground = P_IsObjectOnGround(mo)
	local canstand = true
	
	local thrust = player.speed
	
	if player.displaybob == nil
	or player.panim == PA_ABILITY2
	or not onground
	or thrust <= 2*FRACUNIT
	or (player.reloadticks and player.reloadticks >= 5)
		player.displaybob = 0
	else
		player.displaybob = $ + (75*thrust)
	end
	
	if player.ammo == nil
		player.ammo = 2
	end
	
	//State: ready to gunsling
	if not ((player.pflags & (PF_SLIDING)) or (player.exiting) or (P_PlayerInPain(player)))
	and not (player.weapondelay)
	and not (player.panim == PA_ABILITY2)
		//Trigger firing action
		if (player.cmd.buttons & BT_USE)
			local bullet = nil

			mo.state = S_PLAY_FIRE
			player.panim = PA_ABILITY2
			player.weapondelay = refiretime.value
			if player.ammo <= 0
				S_StartSound(player.mo,misfiresound)
			else 
				player.ammo = $-1
				local firez = mo.z + (mo.height/2)
				bullet = P_SpawnPointMissile(
					mo,
					mo.x + P_ReturnThrustX(nil, mo.angle, FRACUNIT),
					mo.y + P_ReturnThrustY(nil, mo.angle, FRACUNIT),
					firez + (sin(player.aiming)*90),
					player.revitem,
					mo.x, mo.y, firez
				)
			end
			if bullet
			and bullet.valid
				P_InstaThrust(bullet,bullet.angle,corkspeed.value*cos(player.aiming))
				bullet.momz = corkspeed.value*sin(player.aiming)
				bullet.radius = corkradius.value
			end
			player.drawangle = mo.angle
			//Air function
			if not(P_IsObjectOnGround(mo))
				P_SetMobjStateNF(mo,airstate1)
				player.mo.sprite2 = SPR2_FAIR
				player.airgun = true
			end
		end
	end
	
	//Running and jumping
	if player.panim == PA_ABILITY2 and P_IsObjectOnGround(mo) and player.cmd.buttons&BT_JUMP and not(player.popgunhistory&BT_JUMP)
		mo.state = S_PLAY_WALK
	end
	
	//Air gunning
	if not(P_IsObjectOnGround(mo)) and player.airgun == true and player.weapondelay
		if player.weapondelay < refiretime.value-1 and player.weapondelay > refiretime.value-3
			P_SetMobjStateNF(mo,airstate2)
		elseif player.weapondelay < refiretime.value-4
			P_SetMobjStateNF(mo,airstate1)
		end
		--player.pflags = $|PF_JUMPDOWN
	end	
	if P_IsObjectOnGround(mo) and player.airgun == true
	or not player.weapondelay
		player.airgun = false
		if (player.weapondelay) then
			mo.state = S_PLAY_FIRE_FINISH
		end
	end
	
	if player.panim != PA_ABILITY2
		player.laststate = player.panim
		if player.ammo < clipsize.value
		and not(player.weapondelay)
		and player.panim != PA_PAIN
		and player.panim != PA_ABILITY2
			player.reloadticks = $+1
			if player.reloadticks == 5
				S_StartSound(player.mo,reloadsound)
			elseif player.reloadticks > 5
				if player.reloadticks >= 30
					S_StartSound(nil,reloadfinishsound,p)
					player.ammo = clipsize.value
					player.reloadticks = 0
				end
			end
		else
			player.reloadticks = 0
			S_StopSoundByID(player.mo,reloadsound)
		end
	else
		player.reloadticks = 0
		S_StopSoundByID(player.mo,reloadsound)
		if player.weapondelay <= 0
			player.state = S_PLAY_WALK
			player.panim = player.laststate
		end
	end
end

//HUD Function
local drawNewHand = function(v,p,cam)
	local mycam = 1
	if secondarydisplayplayer == p
	and splitscreen
		mycam = 2
	end
	
	if p.displaybob == nil
		return end
	
	local offx = (cos(p.displaybob+ANGLE_90) * 16)
	local offy = (sin(p.displaybob*2) * 16)
	
	if p.exiting
		if handoffx[mycam] >= 75*FRACUNIT
			offx = 100*FRACUNIT
			offy = 16*FRACUNIT
		else
			offx = 80*FRACUNIT
			offy = -16*FRACUNIT
		end
	elseif p.mo.state == S_PLAY_ROLL
	or p.powers[pw_carry] == CR_MINECART
		offx = 0
		offy = 96*FRACUNIT
	elseif p.pflags & PF_BOUNCING
	or p.powers[pw_carry] == CR_PLAYER
	or p.powers[pw_carry] == CR_ROPEHANG
		offy = 25*FRACUNIT + p.mo.momz
		offx = -50*FRACUNIT
	elseif not P_IsObjectOnGround(p.mo)
	or p.fpsslidenow
		offx = 0
		offy = $ + p.mo.momz
	elseif p.powers[pw_carry] == CR_ROLLOUT
		offx = 0 + (16*p.cmd.sidemove)
		
		offy = 32*FRACUNIT
	end
	offy = max($,-16*FRACUNIT)
	
	if p.weapondelay  > refiretime.value/2
		offx = 0
		offy = 0
	elseif p.reloadticks > 5
		local gunease = min(FRACUNIT,p.reloadticks*FRACUNIT/15)
		offx = ease.inoutsine(gunease,0,100*FRACUNIT)
		offy = ease.inback(gunease,0,16*FRACUNIT,FRACUNIT)
	end
	
	local gunsprite = "HUDGUNIDLE"
	local handsprite = nil
	
	handoffy[mycam] = ease.outcubic(FRACUNIT/10,$,offy)
	handoffx[mycam] = ease.outcubic(FRACUNIT/10,$,offx)
	
	if p.weapondelay  > refiretime.value/2
		gunsprite = "HUDGUNFIRE"
	elseif abs(handoffx[mycam]) > 17*FRACUNIT
	or (p.pflags & PF_BOUNCING and p.reloadticks > 5)
		if p.ammo == clipsize.value
			gunsprite = "HUDGUNRELAF"
		else
			gunsprite = "HUDGUNRELAE"
		end
	elseif P_PlayerInPain(p)
	or p.fpsslidenow
	or p.mo.state == S_PLAY_ROLL
	or p.powers[pw_carry] == CR_ROLLOUT
	or p.powers[pw_carry] == CR_PTERABYTE
	or p.powers[pw_carry] == CR_DUSTDEVIL
		gunsprite = "HUDGUNOUCH"
	elseif p.ammo != clipsize.value
		gunsprite = "HUDGUNEMPTY"
	end
	
	if p.reloadticks > 15
	and p.ammo < clipsize.value
		handsprite = "HUDGUNRELBE"
		local handease = max(0,min(FRACUNIT,(p.reloadticks-15)*FRACUNIT/15))
		reloffx[mycam] = ease.outexpo(handease,0,216*FRACUNIT)
		reloffy[mycam] = ease.outexpo(handease,0,-113*FRACUNIT)
	elseif reloffx[mycam] > 0
		handsprite = "HUDGUNRELBF"
		reloffy[mycam] = ease.outexpo(FRACUNIT/50,$,0)
		reloffx[mycam] = ease.outexpo(FRACUNIT/50,$,0)
	end
	
	local colormap = v.getColormap(p.mo.skin,p.mo.color)
	
	if p.mo.eflags & MFE_UNDERWATER
		if p.mo.eflags & MFE_GOOWATER
			colormap = v.getColormap(TC_RAINBOW,SKINCOLOR_MAGENTA)
		else
			colormap = v.getColormap(TC_RAINBOW,SKINCOLOR_MARINE)
		end
	elseif p.mo.colorized
		colormap = v.getColormap(TC_RAINBOW,p.mo.color)
	end
	
	if handsprite
		v.drawScaled(44*FRACUNIT+reloffx[mycam],345*FRACUNIT+reloffy[mycam],3*FRACUNIT,v.cachePatch(handsprite),V_PERPLAYER|V_SNAPTOBOTTOM,colormap)
	end
	v.drawScaled(160*FRACUNIT+handoffx[mycam],216*FRACUNIT+handoffy[mycam],3*FRACUNIT,v.cachePatch(gunsprite),V_PERPLAYER|V_SNAPTOBOTTOM,colormap)
end

////
//Hooks

//Input control before movement is handled
addHook("PreThinkFrame",do
	for player in players.iterate
		if not(IsFang(player))
			return end
		
		if player.pflags & PF_SLIDING
			player.fpsslidenow = true
		else
			player.fpsslidenow = nil
		end
		
		local firebutton = false
		
		if (player.cmd.buttons & BT_ATTACK
		and fireinput.value == 1
		and not G_RingSlingerGametype())
		or (player.cmd.buttons & BT_FIRENORMAL
		and fireinput.value == 2
		and not G_RingSlingerGametype())
		or (player.cmd.buttons & BT_CUSTOM1
		and fireinput.value == 3)
		or (player.cmd.buttons & BT_CUSTOM2
		and fireinput.value == 4)
		or (player.cmd.buttons & BT_CUSTOM3
		and fireinput.value == 5)
			firebutton = true
		end
		
		if firebutton
		and player.powers[pw_carry] != CR_ROPEHANG
			player.cmd.buttons = $|BT_SPIN
		end
	end
end)

//Main body for popgun firing control	
addHook("PlayerThink",function(player)
	if not(IsFang(player)) return end
	
	if player.justspawned == nil
	or player.playerstate != PST_LIVE
	or leveltime == 0
		player.justspawned = false
	end
		
	if player.ammoflash
		player.ammoflash = ($+1)%10
	else
		player.ammoflash = 1
	end
	
	//Disallow native CA2_GUNSLINGER functionality
	if player.charability2 == CA2_GUNSLINGER
		player.charability2 = CA2_NONE 
	end
	
	//Apply ring boost
	if babyface.value
		player.killsbar = max($-1,150*player.kills/babyfacelimit.value)
		if player.barease
			player.barease = $-1
		end
		player.normalspeed = ease.linear(min(FRACUNIT,player.kills*FRACUNIT/babyfacelimit.value),skins[player.skin].normalspeed-(2*FRACUNIT),skins[player.skin].normalspeed+(12*FRACUNIT))
		player.acceleration = ease.linear(min(FRACUNIT,player.kills*FRACUNIT/babyfacelimit.value),37,46)
	else
		player.normalspeed = skins[player.skin].normalspeed
	end

	//Unable to use gun during certain states
	if player.powers[pw_nocontrol]
	or player.powers[pw_carry]
	or player.fpsslidenow
	or (player.playerstate != PST_LIVE and player.jointime != 0)
	or player.exiting 
	or P_PlayerInPain(player)
		player.airgun = false
		player.reloadticks = 0
	return end

	if player.popgunhistory == nil
		player.popgunhistory = player.cmd.buttons
	end
	
	//Do Gunslinger
	newGunslinger(player)
	
	//Make SPR2 behave
	if (player.mo.state == S_PLAY_AIRFIRE1) then
		player.mo.frame = 0
	end
	
	if (player.mo.state == S_PLAY_AIRFIRE2) then
		player.mo.frame = 1
	end
end)

//Update button history
addHook("PostThinkFrame",do
	for player in players.iterate
		player.popgunhistory = player.cmd.buttons	
	end
end)

//Shield ability regulation
addHook("ShieldSpecial",function(player)
	if IsFang(player)
		return true
	end
end)

//HUD
hud.add(function(v, p, cam)
	if not(IsFang(p))
		return end
	
	local hudflags = V_HUDTRANS|V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP
	local ammopatch = "STTAMMO"
	if p.ammo == 0
	and p.ammoflash >= 5
		ammopatch = "STTRAMMO"
	end
	
	v.draw(16,58,v.cachePatch(ammopatch),hudflags)
	v.drawNum(120,58,p.ammo,hudflags)
	
	if babyface.value
		local barx = 0
		if p.barease
			barx = ease.inexpo(min(max(p.barease*FRACUNIT/TICRATE,0),FRACUNIT),0,-300)
		end
		
		v.drawFill(barx+17,72,154,7,0|hudflags)
		v.drawFill(barx+19,74,150,5,30|hudflags)
		v.drawFill(barx+19,74,p.killsbar,5,6|hudflags)
		v.drawFill(barx+19,74,150*p.kills/babyfacelimit.value,5,skincolors[p.skincolor].ramp[2]|hudflags)
		
		v.drawFill(barx+16,79,154,7,4|hudflags)
		v.drawFill(barx+18,79,150,5,26|hudflags)
		v.drawFill(barx+18,79,p.killsbar,5,8|hudflags)
		v.drawFill(barx+18,79,150*p.kills/babyfacelimit.value,5,skincolors[p.skincolor].ramp[4]|hudflags)
		v.drawString(barx+18,88,"BOOST",hudflags)
	end
	
	if not (cam.chase
	or p.awayviewtics
	or p.mo.flags2 & MF2_DONTDRAW)
		drawNewHand(v,p,cam)
	end
	
end, game)

//Give reward when hitting an enemy
addHook("MobjDamage",function(t,i,mo,d,dt)
	if mo
	and i
	and t
	and mo.player
	and mo.skin == "fang"
	and i.type == MT_CORK
		mo.player.reloadticks = 0
		mo.player.ammo = clipsize.value
		mo.player.kills = min(babyfacelimit.value,$+1)
		S_StartSound(nil,hitenemysound,mo.player)
		S_StartSound(nil,reloadfinishsound,mo.player)
	end
end)

addHook("MobjDamage",function(mo,i,s,d,dt)
	if mo
	and mo.player
	and mo.skin == "fang"
		mo.player.kills = max(0,$-3)
	end
end, MT_PLAYER)

addHook("MobjDeath",function(t,i,mo,d,dt)
	if mo
	and i
	and t
	and mo.player
	and mo.skin == "fang"
	and i.type == MT_CORK
	and t.flags & MF_ENEMY
	and ~t.flags & MF_BOSS		
	and not ultimatemode
		mo.player.rings = $+1
		S_StartSound(nil,sfx_itemup,mo.player)
	end
end)

addHook("PlayerSpawn",function(p)
	local mycam = 1
	if secondarydisplayplayer == p
	and splitscreen
		mycam = 2
		camera2.chase = false
	else
		camera.chase = false
	end
	
	handoffx[mycam] = 0
	handoffy[mycam] = 0
	reloffx[mycam] = 0
	reloffy[mycam] = 0
	
	p.ammo = clipsize.value
	p.reloadticks = 0
	p.kills = 0
	p.killsbar = 0
	p.barease = TICRATE
end)